using System;
using System.Data.OracleClient;
using System.Windows.Forms;
using System.Data;

namespace OracleWinForms
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Data.OracleClient.OracleConnection oracleConnection;
		private System.Windows.Forms.Button transferBtn;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox fromTextBox;
		private System.Windows.Forms.TextBox toTextBox;
		private System.Windows.Forms.TextBox amountTextBox;
		private System.Data.OracleClient.OracleCommand oracleSelectCommand1;
		private System.Data.OracleClient.OracleCommand oracleInsertCommand1;
		private System.Data.OracleClient.OracleCommand oracleUpdateCommand1;
		private System.Data.OracleClient.OracleCommand oracleDeleteCommand1;
		private System.Data.OracleClient.OracleDataAdapter accountDataAdapter;
		private System.Windows.Forms.DataGrid dataGrid1;
		private OracleWinForms.AccountDataSet accountDataSet1;
		private System.Windows.Forms.DataGridTableStyle dataGridTableStyle1;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn1;
		private System.Windows.Forms.DataGridTextBoxColumn dataGridTextBoxColumn2;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1() {
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.oracleConnection = new System.Data.OracleClient.OracleConnection();
            this.transferBtn = new System.Windows.Forms.Button();
            this.fromTextBox = new System.Windows.Forms.TextBox();
            this.toTextBox = new System.Windows.Forms.TextBox();
            this.amountTextBox = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.accountDataAdapter = new System.Data.OracleClient.OracleDataAdapter();
            this.oracleDeleteCommand1 = new System.Data.OracleClient.OracleCommand();
            this.oracleInsertCommand1 = new System.Data.OracleClient.OracleCommand();
            this.oracleSelectCommand1 = new System.Data.OracleClient.OracleCommand();
            this.oracleUpdateCommand1 = new System.Data.OracleClient.OracleCommand();
            this.dataGrid1 = new System.Windows.Forms.DataGrid();
            this.accountDataSet1 = new OracleWinForms.AccountDataSet();
            this.dataGridTableStyle1 = new System.Windows.Forms.DataGridTableStyle();
            this.dataGridTextBoxColumn1 = new System.Windows.Forms.DataGridTextBoxColumn();
            this.dataGridTextBoxColumn2 = new System.Windows.Forms.DataGridTextBoxColumn();
            this.button1 = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.accountDataSet1)).BeginInit();
            this.SuspendLayout();
            // 
            // oracleConnection
            // 
            this.oracleConnection.ConnectionString = global::OracleWinForms.Properties.Settings.Default.connectionString;
            // 
            // transferBtn
            // 
            this.transferBtn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.transferBtn.Location = new System.Drawing.Point(352, 16);
            this.transferBtn.Name = "transferBtn";
            this.transferBtn.Size = new System.Drawing.Size(75, 23);
            this.transferBtn.TabIndex = 0;
            this.transferBtn.Text = "Transfer";
            this.transferBtn.Click += new System.EventHandler(this.transferBtn_Click);
            // 
            // fromTextBox
            // 
            this.fromTextBox.Location = new System.Drawing.Point(64, 16);
            this.fromTextBox.Name = "fromTextBox";
            this.fromTextBox.Size = new System.Drawing.Size(32, 20);
            this.fromTextBox.TabIndex = 2;
            this.fromTextBox.Text = "1";
            // 
            // toTextBox
            // 
            this.toTextBox.Location = new System.Drawing.Point(144, 16);
            this.toTextBox.Name = "toTextBox";
            this.toTextBox.Size = new System.Drawing.Size(40, 20);
            this.toTextBox.TabIndex = 3;
            this.toTextBox.Text = "2";
            // 
            // amountTextBox
            // 
            this.amountTextBox.Location = new System.Drawing.Point(256, 16);
            this.amountTextBox.Name = "amountTextBox";
            this.amountTextBox.Size = new System.Drawing.Size(80, 20);
            this.amountTextBox.TabIndex = 4;
            this.amountTextBox.Text = "10";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(32, 20);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(32, 16);
            this.label1.TabIndex = 5;
            this.label1.Text = "from";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(120, 20);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(24, 14);
            this.label2.TabIndex = 6;
            this.label2.Text = "to";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(202, 19);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(48, 14);
            this.label3.TabIndex = 7;
            this.label3.Text = "amount";
            // 
            // accountDataAdapter
            // 
            this.accountDataAdapter.DeleteCommand = this.oracleDeleteCommand1;
            this.accountDataAdapter.InsertCommand = this.oracleInsertCommand1;
            this.accountDataAdapter.SelectCommand = this.oracleSelectCommand1;
            this.accountDataAdapter.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
            new System.Data.Common.DataTableMapping("Table", "ACCOUNT", new System.Data.Common.DataColumnMapping[] {
                        new System.Data.Common.DataColumnMapping("ID", "ID"),
                        new System.Data.Common.DataColumnMapping("PERSON_ID", "PERSON_ID"),
                        new System.Data.Common.DataColumnMapping("AMOUNT", "AMOUNT")})});
            this.accountDataAdapter.UpdateCommand = this.oracleUpdateCommand1;
            // 
            // oracleDeleteCommand1
            // 
            this.oracleDeleteCommand1.CommandText = resources.GetString("oracleDeleteCommand1.CommandText");
            this.oracleDeleteCommand1.Connection = this.oracleConnection;
            this.oracleDeleteCommand1.Parameters.AddRange(new System.Data.OracleClient.OracleParameter[] {
            new System.Data.OracleClient.OracleParameter(":Original_ID", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(38)), ((byte)(0)), "ID", System.Data.DataRowVersion.Original, null),
            new System.Data.OracleClient.OracleParameter(":Original_AMOUNT", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(17)), ((byte)(3)), "AMOUNT", System.Data.DataRowVersion.Original, null),
            new System.Data.OracleClient.OracleParameter(":Original_PERSON_ID", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(38)), ((byte)(0)), "PERSON_ID", System.Data.DataRowVersion.Original, null)});
            // 
            // oracleInsertCommand1
            // 
            this.oracleInsertCommand1.CommandText = "INSERT INTO ACCOUNT(ID, PERSON_ID, AMOUNT) VALUES (:ID, :PERSON_ID, :AMOUNT)";
            this.oracleInsertCommand1.Connection = this.oracleConnection;
            this.oracleInsertCommand1.Parameters.AddRange(new System.Data.OracleClient.OracleParameter[] {
            new System.Data.OracleClient.OracleParameter(":ID", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(38)), ((byte)(0)), "ID", System.Data.DataRowVersion.Current, null),
            new System.Data.OracleClient.OracleParameter(":PERSON_ID", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(38)), ((byte)(0)), "PERSON_ID", System.Data.DataRowVersion.Current, null),
            new System.Data.OracleClient.OracleParameter(":AMOUNT", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(17)), ((byte)(3)), "AMOUNT", System.Data.DataRowVersion.Current, null)});
            // 
            // oracleSelectCommand1
            // 
            this.oracleSelectCommand1.CommandText = "SELECT ID, PERSON_ID, AMOUNT FROM ACCOUNT";
            this.oracleSelectCommand1.Connection = this.oracleConnection;
            // 
            // oracleUpdateCommand1
            // 
            this.oracleUpdateCommand1.CommandText = resources.GetString("oracleUpdateCommand1.CommandText");
            this.oracleUpdateCommand1.Connection = this.oracleConnection;
            this.oracleUpdateCommand1.Parameters.AddRange(new System.Data.OracleClient.OracleParameter[] {
            new System.Data.OracleClient.OracleParameter(":ID", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(38)), ((byte)(0)), "ID", System.Data.DataRowVersion.Current, null),
            new System.Data.OracleClient.OracleParameter(":PERSON_ID", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(38)), ((byte)(0)), "PERSON_ID", System.Data.DataRowVersion.Current, null),
            new System.Data.OracleClient.OracleParameter(":AMOUNT", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(17)), ((byte)(3)), "AMOUNT", System.Data.DataRowVersion.Current, null),
            new System.Data.OracleClient.OracleParameter(":Original_ID", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(38)), ((byte)(0)), "ID", System.Data.DataRowVersion.Original, null),
            new System.Data.OracleClient.OracleParameter(":Original_AMOUNT", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(17)), ((byte)(3)), "AMOUNT", System.Data.DataRowVersion.Original, null),
            new System.Data.OracleClient.OracleParameter(":Original_PERSON_ID", System.Data.OracleClient.OracleType.Number, 0, System.Data.ParameterDirection.Input, false, ((byte)(38)), ((byte)(0)), "PERSON_ID", System.Data.DataRowVersion.Original, null)});
            // 
            // dataGrid1
            // 
            this.dataGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.dataGrid1.DataMember = "ACCOUNT";
            this.dataGrid1.DataSource = this.accountDataSet1;
            this.dataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dataGrid1.Location = new System.Drawing.Point(16, 56);
            this.dataGrid1.Name = "dataGrid1";
            this.dataGrid1.Size = new System.Drawing.Size(416, 112);
            this.dataGrid1.TabIndex = 8;
            this.dataGrid1.TableStyles.AddRange(new System.Windows.Forms.DataGridTableStyle[] {
            this.dataGridTableStyle1});
            // 
            // accountDataSet1
            // 
            this.accountDataSet1.DataSetName = "AccountDataSet";
            this.accountDataSet1.Locale = new System.Globalization.CultureInfo("ru-RU");
            this.accountDataSet1.SchemaSerializationMode = System.Data.SchemaSerializationMode.IncludeSchema;
            // 
            // dataGridTableStyle1
            // 
            this.dataGridTableStyle1.DataGrid = this.dataGrid1;
            this.dataGridTableStyle1.GridColumnStyles.AddRange(new System.Windows.Forms.DataGridColumnStyle[] {
            this.dataGridTextBoxColumn1,
            this.dataGridTextBoxColumn2});
            this.dataGridTableStyle1.HeaderForeColor = System.Drawing.SystemColors.ControlText;
            this.dataGridTableStyle1.MappingName = "ACCOUNT";
            // 
            // dataGridTextBoxColumn1
            // 
            this.dataGridTextBoxColumn1.Format = "";
            this.dataGridTextBoxColumn1.FormatInfo = null;
            this.dataGridTextBoxColumn1.HeaderText = "Person ID";
            this.dataGridTextBoxColumn1.MappingName = "PERSON_ID";
            this.dataGridTextBoxColumn1.Width = 75;
            // 
            // dataGridTextBoxColumn2
            // 
            this.dataGridTextBoxColumn2.Format = "";
            this.dataGridTextBoxColumn2.FormatInfo = null;
            this.dataGridTextBoxColumn2.HeaderText = "Amount ($)";
            this.dataGridTextBoxColumn2.MappingName = "AMOUNT";
            this.dataGridTextBoxColumn2.Width = 75;
            // 
            // button1
            // 
            this.button1.Location = new System.Drawing.Point(264, 176);
            this.button1.Name = "button1";
            this.button1.Size = new System.Drawing.Size(75, 23);
            this.button1.TabIndex = 9;
            this.button1.Text = "button1";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(448, 206);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.dataGrid1);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.amountTextBox);
            this.Controls.Add(this.toTextBox);
            this.Controls.Add(this.fromTextBox);
            this.Controls.Add(this.transferBtn);
            this.Name = "Form1";
            this.Text = "Form1";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.dataGrid1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.accountDataSet1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private AccountService accountService = new AccountService();

		private void transferBtn_Click(object sender, System.EventArgs e) {
			accountService.transfer(int.Parse(fromTextBox.Text), 
					 int.Parse(toTextBox.Text), 
					 double.Parse(amountTextBox.Text));
			refresh();			
		}

		private void refresh() {
			//DataSet ds = new DataSet();
			accountDataAdapter.Fill(accountDataSet1);			
			// ds.Tables["ACCOUNT"].Rows.Add();
			// accountDataAdapter.Update(ds);
			// dataGrid1.DataSource = ds;
			// dataGrid1.DataMember = "ACCOUNT";			
			// accountDataSet1.ACCOUNT.AddACCOUNTRow()
		}

		

		private void Form1_Load(object sender, System.EventArgs e)
		{
            accountService.Connection = oracleConnection;
			refresh();
		}

		private void button1_Click(object sender, System.EventArgs e) {
			System.Windows.Forms.MessageBox.Show(accountDataSet1.GetXml());
			// accountDataSet1.ReadXml()
		}
	}
}
